SEDIT  ;sedit
 	DB	0		;system flag #-1
 SYSTEM
 	DB	0		;system flag #1
 ; bit 7 = 1 = text entry mode
 ; bit 6 = 1 = double wide mode
 ; bit 5 = 1 = buffer contains data not updated to video
 ; bit 4 = 1 = "trace" mode ON
 ; bit 3 = 1 = grid mode ON
 ; bit 2 = 1 = solid angles
 ; bit 1 = 1 = erase mode
 ; bit 0 = 1 = draw mode
 	DB	0		;+1, # memory buffers
 	DB	1		;+2, horizontal speed
 	DB	1		;+3, vertical speed
 	DW	0		;+4+5, graphic mode posit
 	DW	0		;+6+7, text mode position
 	DW	0		;+8+9, temp storage
 	DB	0		;+10 temp
 	DB	0		;+11 temp
 	DB	0		;+12 temp
 	DW	0		;+13+14, temp
 	DW	0		;+15+16, temp
 	DW	0		;+17+18, temp
 MASK	DB	0,0,0,0,0,0,0	;keyboard mask area
 ZERTBL	LD	HL,BUFFTABLE	;set all buffers empty
 	LD	DE,BUFFTABLE+1
 	LD	(HL),0		;99 indicates active
 	LD	BC,229
 	LDIR
 	RET
 ENTRY	LD	IY,SYSTEM	;point to parameter table
 	LD	(STACK),SP	;save stack pointer
 	LD	BC,0
 	CALL	60H
 	CALL	60H
 	LD	HL,3FFFH
 	LD	E,(HL)
 	LD	A,60H
 	LD	(HL),A
 	CP	(HL)
 	LD	(HL),E
 	JP	NZ,KEYS0K
 	LD	HL,KEYS2
 	LD	DE,KEYS3
 	LD	B,32
 EXKEY	LD	A,(HL)
 	EX	AF,AF'
 	LD	A,(DE)
 	LD	(HL),A
 	EX	AF,AF'
 	LD	(DE),A
 	INC	HL
 	INC	DE
 	DJNZ	EXKEY
 KEYS0K	LD	A,(3804H)	;check for "R"
 	AND	4
 	CALL	Z,ZERTBL	;clear the table if not
 	LD	A,(4)		;check for Mod I or III
 	CP	30H		;compare to III
 	SET	5,(IY-1)	;set Mod III
 	LD	HL,(4411H)	;get top of mem III
 	JR	Z,HTPMEM	;if Z, then have it
 	LD	HL,(4049H)	;else get top mem I
 	RES	5,(IY-1)	;set Mod I
 HTPMEM	LD	DE,BUFFER+400H	;point to first buffer
 	OR	A		;clear carry flag
 	SBC	HL,DE		;how much memory avail
 	DEC	H		;don't use last partial
 	LD	A,H		;get into A for math
 	SRL	A		;divide by 2
 	SRL	A		;again, 400H per buffer
 	LD	(IY+1),A	;# buffers available
 	LD	A,(3804H)	;check for "R" again
 	AND	4
 	CALL	Z,CLRBUFF	;don't clear screen
 HALTER	LD	A,(3840H)
 	AND	80H
 	JR	NZ,HALTER
 MENU	LD	HL,MESG		;menu page
 	CALL	PRINT		;display it
 	CALL	FLKEY		;flash <KEY> message
 RESUME	LD	SP,0		;set stack
 STACK	EQU	$-2
 	CALL	PUTBUFF		;draw buffer
 LOOP	CALL	KEY		;wait for a key
 	SET	5,(IY)		;buffer updated
 	CP	141
 	JP	Z,SCREENPRT
 	CP	160
 	JP	Z,SCREENPRT
 	CP	176
 	JP	Z,SCREENPRT
 	BIT	7,(IY)		;text entry mode?
 	JR	Z,NOTTXT	;nope if not set
 	CP	81H		;check for control key
 	JP	C,TEXTENTRY	;put it on if not control
 NOTTXT	AND	7FH		;remove control bit
 	CALL	UCASE		;make it upper case
 	CP	'G'
 	JP	Z,LOAD		;load file
 	CP	'P'
 	JP	Z,SAVE		;save file
 	CP	'B'
 	JP	Z,DOBUFF	;buffer control
 	CP	'A'
 	JP	Z,ANGLES	;angle control
 	CP	'T'
 	JP	Z,TEXTCHG	;toggle text control
 	CP	'R'
 	JP	Z,REVERSE	;reverse character set
 	CP	'S'
 	JP	Z,SKIP		;skip mode
 	CP	'D'
 	JP	Z,DRAW		;draw mode
 	CP	'E'
 	JP	Z,ERASE		;erase mode
 	CP	'M'
 	JP	Z,MENU		;display menu
 	CP	'?'
 	JP	Z,PARAMETERS	;display settings
 	CP	'/'
 	JP	Z,PARAMETERS
 	CP	'F'
 	JP	Z,FLASH		;set flash speed
 	CP	'C'
 	JP	Z,CLEAR
 	CP	'V'
 	JP	Z,VIDEO		;reverse video size
 	CP	'Q'
 	JP	Z,QUIT		;back to dos
 	CP	5BH
 	JP	Z,UARROW
 	CP	5CH
 	JP	Z,DARROW
 	CP	5DH
 	JP	Z,LARROW
 	CP	5EH
 	JP	Z,RARROW
 	CP	18H
 	JP	Z,SUARROW
 	CP	19H
 	JP	Z,SDARROW
 	CP	1AH
 	JP	Z,SLARROW
 	CP	1BH
 	JP	Z,SRARROW
 	CP	'I'
 	JP	Z,LUARROW
 	CP	'K'
 	JP	Z,LDARROW
 	CP	'O'
 	JP	Z,RUARROW
 	CP	'L'
 	JP	Z,RDARROW
 	CP	'@'
 	JP	Z,SPECIAL
 	CP	'`'
 	JP	Z,SPECIAL
 	CP	'W'
 	JP	Z,WATCH
 	CP	'U'
 	JP	Z,TRACE
 	CP	'J'
 	JP	Z,GRID
 	CP	'X'
 	JP	Z,REVVID
 	CP	'Y'
 	JP	Z,REVVID2
 	CP	'Z'
 	JP	Z,MOVVID
 	CP	'H'
 	JR	Z,HOME
 	CP	'N'
 	JP	Z,DUBREV
 	RES	5,(IY)		;buffer not updated
 	JP	LOOP		;invalid key
 HOME	XOR	A
 	LD	(IY+4),A
 	LD	(IY+5),A
 	LD	(IY+6),A
 	LD	(IY+7),A
 	SET	5,(IY)
 	JP	RESUME
 TEXTENTRY
 	CP	18H
 	JP	Z,SUARROW
 	CP	19H
 	JP	Z,SDARROW
 	CP	1AH
 	JP	Z,SLARROW
 	CP	1BH
 	JP	Z,SRARROW
 	CP	5BH
 	JP	Z,UARROWX
 	CP	5CH
 	JP	Z,DARROWX
 	CP	5DH
 	JP	Z,LARROWX
 	CP	5EH
 	JP	Z,RARROWX
 	CP	7FH
 	JR	NZ,TEXTRET
 	LD	A,191
 TEXTRET	PUSH	AF		;save character
 	LD	A,(IY)		;save size
 	PUSH	AF		;save on stack
 	RES	6,(IY)		;force non-adjust for buf
 	CALL	FIGTPOS		;compute the position
 	POP	AF		;restore size
 	LD	(IY),A		;put it back
 	POP	AF		;restore character
 	LD	HL,BUFFER	;put in buffer
 	ADD	HL,DE		;point to position
 	LD	(HL),A		;put it in
 	SET	5,(IY)		;buffer has new data
 	JP	RARROWX		;go next position
 TEXTCHG	LD	A,(IY)		;get text flag
 	XOR	80H		;reverse bit 7
 	LD	(IY),A		;put it back
 	JP	RESUME		;continue
 SIZFIX	BIT	6,(IY)		;set parameters
 	LD	HL,7F3FH	;single	wide video
 	RET	Z
 	LD	HL,4020H	;half the values
 	RET			;must be even number
 SIZFIX2	BIT	7,(IY)		;text entry?
 	JR	Z,SIZFIX
 	LD	HL,3F0FH	;max text entry
 	BIT	6,(IY)		;check size
 	RET	Z
 	LD	HL,1E0FH
 	RET
 SRARROW	CALL	DORARROW	;do it
 	CALL	DORARROW	;again
 	CALL	DORARROW	;real fast
 	JP	RESUME		;continue
 RARROW	BIT	7,(IY)
 	JP	NZ,TEXTRET
 RARROWX	CALL	DORARROW
 	JP	RESUME
 DORARROW	SET	5,(IY)	;new buffer data
 	CALL	SIZFIX		;get max values
 	LD	A,H
 	LD	(RFIX1),A
 	LD	A,L
 	LD	(RFIX2),A
 	BIT	7,(IY)		;text entry ?
 	JR	NZ,RTEXT	;move text
 	LD	A,(IY+5)	;get vertical position
 	CP	127		;compare for last posit
 RFIX1	EQU	$-1		;set from above
 	RET	Z		;don't change
 	INC	A
 	LD	(IY+5),A	;put it back
 	JP	DRAWIT		;draw the new spot
 RTEXT	LD	A,(IY+7)	;vertical text position
 	CP	63		;at end?
 RFIX2	EQU	$-1
 	RET	Z
 	INC	A		;move one more
 RCFIX	LD	(IY+7),A	;update new spot
 	RET
 SLARROW	CALL	DOLARROW
 	CALL	DOLARROW
 	CALL	DOLARROW
 	JP	RESUME
 LARROW	BIT	7,(IY)
 	JP	NZ,TEXTRET
 LARROWX	CALL	DOLARROW
 	JP	RESUME
 DOLARROW	SET	5,(IY)	;updated buffer
 	BIT	7,(IY)		;text entry?
 	JR	NZ,LTEXT
 	LD	A,(IY+5)
 	OR	A
 	RET	Z
 	DEC	A
 	LD	(IY+5),A
 	JP	DRAWIT
 LTEXT	LD	A,(IY+7)
 	OR	A
 	RET	Z
 	DEC	A
 	LD	(IY+7),A
 	RET
 RUARROW	LD	HL,DORARROW
 	LD	DE,DOUARROW
 	JR	ACOMM		;go common
 RDARROW	LD	HL,DORARROW
 	LD	DE,DODARROW
 	JR	ACOMM
 LUARROW	LD	HL,DOLARROW
 	LD	DE,DOUARROW
 	JR	ACOMM
 LDARROW	LD	HL,DOLARROW
 	LD	DE,DODARROW
 ACOMM	LD	(CAL1),HL
 	LD	(CAL2),DE
 	LD	A,(IY)		;save flag
 	PUSH	AF		;save on stack
 	BIT	2,(IY)		;solid?
 	JR	Z,AXLP		;continue if yes
 	AND	0FCH		;mask out low 2 bits
 	LD	(IY),A
 AXLP	LD	A,(IY+2)	;get horiz speed
 ACLOOP	PUSH	AF		;save count
 	CALL	0		;horizontal call
 CAL1	EQU	$-2
 	POP	AF
 	DEC	A
 	JR	NZ,ACLOOP
 	LD	A,(IY+3)	;get vertical speed
 AVLOOP	PUSH	AF		;save counter
 	CALL	0		;vertical call
 CAL2	EQU	$-2
 	POP	AF
 	DEC	A
 	JR	NZ,AVLOOP	;continue
 	POP	AF
 	LD	(IY),A
 	JP	RESUME		;continue
 SUARROW	CALL	DOUARROW
 	CALL	DOUARROW
 	CALL	DOUARROW
 	JP	RESUME
 UARROW	BIT	7,(IY)
 	JP	NZ,TEXTRET
 UARROWX	CALL	DOUARROW
 	JP	RESUME
 DOUARROW	SET	5,(IY)
 	BIT	7,(IY)
 	JR	NZ,UTEXT
 	LD	A,(IY+4)	;get horizontal posit
 	OR	A
 	RET	Z
 	DEC	A
 	LD	(IY+4),A
 	JP	DRAWIT
 UTEXT	LD	A,(IY+6)
 	OR	A
 	RET	Z
 	DEC	A
 	LD	(IY+6),A
 	RET
 SDARROW	CALL	DODARROW
 	CALL	DODARROW
 	CALL	DODARROW
 	JP	RESUME
 DARROW	BIT	7,(IY)
 	JP	NZ,TEXTRET
 DARROWX	CALL	DODARROW
 	JP	RESUME
 DODARROW	SET	5,(IY)
 	BIT	7,(IY)
 	JR	NZ,DTEXT
 	LD	A,(IY+4)
 	CP	47
 	RET	Z
 	INC	A
 	LD	(IY+4),A
 	JP	DRAWIT
 DTEXT	LD	A,(IY+6)
 	CP	15
 	RET	Z
 	INC	A
 	LD	(IY+6),A
 	RET
 DRAWIT	LD	A,(IY)		;get mode
 	AND	3		;anything?
 	RET	Z		;nope, no change
 	LD	A,(IY)		;get it back
 	PUSH	AF		;save on stack
 	BIT	1,A		;check for ERASE
 	RES	6,(IY)		;set single wide
 	JR	NZ,DRWER	;do it
 	CALL	SET		;turn it on
 	JR	DRWER+3
 DRWER	CALL	RESET		;turn it off
 	POP	AF
 	LD	(IY),A		;replace original
 	SET	5,(IY)		;buffer has changed
 	RET
 VIDEO	BIT	6,(IY)		;check for size
 	JR	NZ,GOVIDEO
 	RES	0,(IY+5)
 	RES	0,(IY+7)
 	LD	A,(IY+5)
 	BIT	7,(IY)		;text entry?
 	JR	Z,VIDE1
 	LD	A,(IY+7)
 VIDE1	INC	A
 	CP	L
 	JR	C,GOVIDEO	;don't adjust
 	LD	A,30		;set at right side
 	LD	(IY+7),A	;set text position
 	LD	A,62
 	LD	(IY+5),A	;graphic position
 GOVIDEO	LD	A,(IY)		;get size
 	XOR	40H		;reverse it
 	LD	(IY),A		;put it back
 	SET	5,(IY)		;update the video
 	JP	RESUME		;re-draw it
 GRID	LD	A,(IY)		;get grid flag
 	XOR	8		;reverse bit 3
 	SET	5,A		;set updated screen
 	LD	(IY),A
 	JP	RESUME		;continue
 DOGRID	LD	HL,3C00H
 	LD	(SBUFF),HL	;where to set the points
 	LD	IX,GRIDTABL
 	BIT	6,(IY)
 	JR	NZ,GRIDLP
 	LD	IX,GRIDTABLE
 GRIDLP	LD	D,(IX)		;get horiz
 	LD	E,(IX+1)
 	LD	A,D
 	CP	-1
 	RET	Z
 	LD	A,0C6H
 	LD	(INST+1),A
 	CALL	DOSET
 	INC	IX
 	INC	IX		;next entry
 	JR	GRIDLP
 SKIP	RES	0,(IY)		;reset draw mode
 	RES	1,(IY)		;reset erase mode
 	JR	SCOMM
 ERASE	RES	0,(IY)		;reset draw mode
 	SET	1,(IY)		;set erase mode
 	JR	SCOMM
 DRAW	SET	0,(IY)		;set draw mode
 	RES	1,(IY)		;reset erase mode
 SCOMM	CALL	DRAWIT		;display it
 	JP	RESUME		;continue
 TRACE	LD	A,(IY)		;get flag
 	XOR	10H		;reverse bit 4
 	SET	5,A		;set update flag
 	LD	(IY),A
 	JP	RESUME		;continue
 WATCH	BIT	6,(IY)		;double size?
 	JP	NZ,RESUME	;cancel if yes
 	LD	HL,WATMSG
 	CALL	PRINT
 	LD	B,3
 	CALL	GETSTR
 	SET	1,(IY-1)
 	JR	Z,DOWATCH
 	CALL	VALUE
 	JP	C,RESUME	;invalid
 	LD	A,C
 	LD	(DLYNUM),A	;save it
 	RES	1,(IY-1)
 DOWATCH	LD	HL,BUFFTABLE	;start of table
 	LD	B,(IY+1)
 	LD	C,1
 	SET	5,(IY)		;re-draw video when done
 WATCHLP	LD	A,(HL)		;active?
 	CP	99
 	JR	NZ,WATNXT	;skip this one
 	PUSH	HL		;save these
 	PUSH	BC
 	LD	HL,BUFFER
 	LD	DE,400H		;length of buffer
 	LD	A,C		;get buffer number
 WATLP	ADD	HL,DE
 	DEC	C
 	JR	NZ,WATLP	;position to area
 	LD	DE,3C00H	;video
 	LD	BC,1024		;length of video
 	LDIR			;display buffer
 	NOP
 	CALL	ASCII		;convert buff # to ascii
 	LD	(3C3EH),BC	;put on video
 	POP	BC		;restore counters
 	POP	HL		;next
 	BIT	1,(IY-1)
 	JR	NZ,WAT1		;pause
 	LD	A,0		;get counter
 DLYNUM	EQU	$-1
 	PUSH	BC
 DLYGO	LD	BC,2000H
 	PUSH	AF
 	CALL	60H
 	POP	AF
 	DEC	A
 	JR	NZ,DLYGO
 	POP	BC
 	JR	WATNXT
 WAT1	LD	A,(387FH)	;wait till no keys
 	OR	A
 	JR	NZ,WAT1
 WAT2	LD	A,(3840H)	;now wait till spacebar
 	AND	80H
 	JR	Z,WAT2		;wait here
 WATNXT	LD	A,(3840H)
 	AND	4
 	JP	NZ,RESUME
 	INC	HL
 	INC	C		;bump counter
 	DJNZ	WATCHLP		;do 'em all
 	JP	RESUME		;re-draw screen
 CLEAR	CALL	KEY		;must be pressed again
 	CP	'C'+80H		;control C?
 	JP	NZ,RESUME	;cancel routine
 	CALL	CLRBUFF		;zero the buffer
 	JP	RESUME		;redraw and continue
 SPECIAL	BIT	7,(IY)		;check for text entry
 	JP	Z,LOOP		;non valid in graphics
 	LD	HL,3FC0H	;last line video
 	LD	(4020H),HL	;where cursor goes
 	LD	HL,AREAMSG
 	BIT	5,(IY)		;MOD III?
 	JR	Z,UR01
 	LD	HL,AREAMSG3
 UR01	CALL	PRINT
 	CALL	KEYWT		;get the key
 	CALL	UCASE
 	LD	(IY+8),A	;save this key
 	LD	HL,(4020H)	;get cursor
 	LD	(HL),A		;put on screen
 	CALL	INCHL
 	LD	(4020H),HL
 	CALL	KEYWT		;get next key
 	CALL	UCASE
 	LD	(IY+9),A	;save it here
 	LD	HL,(4020H)
 	LD	(HL),A		;display it
 	CALL	INCHL
 	LD	(4020H),HL	;update cursor
 	LD	HL,ACTMSG1	;action msg (graphic)
 	CALL	PRINT		;display it
 	CALL	KEYWT
 	CALL	UCASE
 	LD	(IY+10),A	;save it
 	LD	HL,(4020H)
 	LD	(HL),A
 	CALL	INCHL
 	LD	(4020H),HL
 AREANXT	CALL	SIZFIX2		;load HL with max val's
 	LD	A,L
 	LD	(IY+15),A	;max top
 	LD	A,H
 	LD	(IY+13),A	;max right
 	XOR	A
 	LD	(IY+12),A	;max left
 	LD	(IY+14),A	;max right
 	LD	A,(IY+8)	;get first indicator
 	CALL	SETARR		;setup arrows
 	JP	NXAREA		;continue
 SETARR	CALL	ADJARR		;adjust arrows
 	CP	5BH
 	JR	Z,ARUP
 	CP	5CH
 	JR	Z,ARDN
 	CP	5DH
 	JR	Z,ARLF
 	CP	5EH
 	JR	Z,ARRT
 	JP	RESUME		;invalid entry
 ARRT	LD	A,(IY+5)	;get horizontal posit
 	BIT	7,(IY)		;text entry?
 	JR	Z,QBZ1
 	LD	A,(IY+7)	;get text posit
 QBZ1	LD	(IY+12),A	;set left boundry
 	RET			;done
 ARLF	LD	A,(IY+5)	;get horizontal
 	BIT	7,(IY)
 	JR	Z,QBZ2
 	LD	A,(IY+7)
 QBZ2	LD	(IY+13),A	;set max right
 	RET
 ARDN	LD	A,(IY+4)	;get vertical
 	BIT	7,(IY)
 	JR	Z,QBZ3
 	LD	A,(IY+6)
 QBZ3	LD	(IY+14),A	;save lower bound
 	RET
 ARUP	LD	A,(IY+4)
 	BIT	7,(IY)
 	JR	Z,QBZ4
 	LD	A,(IY+6)
 QBZ4	LD	(IY+15),A	;top boundry
 	RET
 NXAREA	LD	A,(IY+9)	;second area
 	CP	'A'		;all?
 	JR	Z,CONTAREA	;have the area
 	CP	'L'		;set a line?
 	JR	Z,SETLINE
 	CALL	SETARR		;setup arrows area
 	JR	CONTAREA	;continue
 SETLINE	LD	A,(IY+8)	;get first area
 	CP	5BH
 	JR	Z,VSETUP	;setup for vertical
 	CP	5CH
 	JR	Z,VSETUP
 	LD	A,(IY+6)
 	LD	(IY+14),A
 	LD	(IY+15),A
 	JR	CONTAREA
 VSETUP	LD	A,(IY+7)
 	LD	(IY+12),A
 	LD	(IY+13),A
 CONTAREA
 	LD	A,(IY+10)	;get action key
 	JR	AREATXT		;do it in text
 ADJARR	CP	18H
 	RET	C
 	CP	1CH
 	RET	NC
 	ADD	A,67
 	RET
 AREATXT	LD	HL,PERFILL
 	CP	'F'
 	JR	Z,GOTPER
 	LD	HL,PERREV
 	CP	'R'
 	JR	Z,GOTPER
 	LD	HL,PERCLR
 	CP	'C'
 	JR	Z,GOTPER
 	CP	'D'
 	LD	HL,PERDUP
 	JP	NZ,RESUME	;forget it
 GOTPER	LD	(PERCALL),HL	;save calling address
 	LD	A,(IY+12)	;save left area
 	LD	(IY+8),A	;save it here
 	CALL	FIGTPOS		;get position
 	LD	HL,BUFFER
 	ADD	HL,DE
 	LD	A,(HL)
 	LD	(IY+9),A	;save it here
 PERLP	LD	L,(IY+12)	;get left
 	LD	H,(IY+14)	;get top
 	CALL	FIGPOS		;compute position
 	LD	HL,BUFFER
 	ADD	HL,DE
 	CALL	0		;set from above
 PERCALL	EQU	$-2
 	LD	A,(IY+12)	;get left
 	INC	A		;bump it
 	LD	(IY+12),A	;re-save it
 	CP	(IY+13)		;check for bounds
 	JR	Z,PERLP		;go if the same
 	JR	C,PERLP		;or less
 	LD	A,(IY+8)	;restore value
 	LD	(IY+12),A	;starting position
 	LD	A,(IY+14)	;get vertical
 	INC	A		;bump this
 	LD	(IY+14),A	;re-save it
 	CP	(IY+15)		;check for bounds
 	JR	Z$PERLP		;go if the same
 	JR	C,PERLP		;or less
 	JP	RESUME		;done now
 PERFILL	LD	(HL),191	;all bits on
 	RET			;done
 PERREV	LD	A,(HL)		;grahics?
 	BIT	7,A		;graphic bit on?
 	RET	Z		;don't do if not
 	CPL			;reverse it
 	SET	7,A
 	RES	6,A
 	LD	(HL),A		;re-display it
 	RET
 PERCLR	LD	(HL),80H	;all bits off
 	RET
 PERDUP	LD	A,(IY+9)	;get duplicate byte
 	LD	(HL),A		;display it
 	RET			;done
 QUIT	CALL	KEY
 	CP	'Q'+80H
 	JP	NZ,RESUME
 	LD	HL,QUITMSG
 	CALL	PRINT		;display it
 	JP	402DH		;back to DOS
 CLRBUFF	LD	HL,BUFFER	;clear the buffer
 	LD	DE,BUFFER+1
 	LD	BC,1023
 	LD	(HL),80H	;graphic "spaces"
 	LDIR
 	NOP
 	SET	5,(IY)		;new data
 	RET
 REVERSE	LD	HL,BUFFER	;where data lies
 	LD	BC,1024		;1k of data
 REVLP	LD	A,(HL)		;get a byte
 	BIT	7,A		;graphics?
 	JR	Z,REVNXT	;skip if yes
 	CPL			;reverse all bits
 	SET	7,A		;turn on graphic
 	RES	6,A
 	LD	(HL),A		;put it back
 REVNXT	INC	HL		;bump buffer
 	DEC	BC
 	LD	A,B		;any more?
 	OR	C
 	JR	NZ,REVLP
 	SET	5,(IY)		;new data
 	JP	RESUME		;re-draw it now
 PUTBUFF	BIT	5,(IY)		;new data ?
 	RET	Z		;forget this
 	BIT	5,(IY-1)	;check for Mod I or III
 	JR	NZ,PUTIII	;do it special
 	BIT	6,(IY)		;check size
 	LD	A,0		;for the port
 	JR	Z,PUTI		;have the byte
 	LD	A,8		;else set double wide
 PUTI	OUT	(0FFH),A	;set the hardware
 	JR	PUTCONT		;continue
 PUTIII	BIT	6,(IY)		;get size
 	LD	A,20H		;single byte
 	JR	Z,PUTIIIX
 	LD	A,24H		;set double wide
 PUTIIIX	OUT	(0ECH),A	;do it
 PUTCONT	JP	Z,PUTSNG	;do it LDIR
 	LD	HL,BUFFER	;data area
 	LD	DE,3C00H	;video
 	LD	B,16		;16 lines to do
 PUTLPO	LD	C,32		;32 chars / line
 	PUSH	HL
 	PUSH	DE
 PUTLPI	LD	A,(HL)		;get data byte
 	LD	(DE),A		;to the video
 	NOP
 	INC	HL		;bump buffer
 	INC	DE		;bump video twice
 	INC	DE
 	DEC	C		;do this line
 	JR	NZ,PUTLPI	;continue
 	POP	DE		;get start pointers back
 	POP	HL
 	PUSH	BC		;save count
 	LD	BC,40H		;next line
 	ADD	HL,BC		;add to both
 	EX	DE,HL
 	ADD	HL,BC
 	EX	DE,HL
 	POP	BC
 	DJNZ	PUTLPO		;continue 16 rows
 RESPUT	RES	5,(IY)		;data updated
 	BIT	3,(IY)		;grid ON
 	CALL	NZ,DOGRID	;display if yes
 	BIT	4,(IY)		;"trace" ON?
 	RET	Z
 	LD	HL,3C00H+57	;single wide start
 	BIT	6,(IY)		;check video flag
 	JR	Z,TRSNG
 	LD	L,50		;double wide start
 TRSNG	LD	DE,GXMSG	;text table (8 bytes)
 	LD	A,20H		;space
 	BIT	7,(IY)		;text entry?
 	JR	NZ,TRSGG
 	LD	A,'>'
 TRSGG	EX	AF,AF'		;store it here
 	LD	A,(IY+5)	;graphic horizontal
 	CALL	PUTTRACE	;display it
 	LD	A,(IY+4)	;graphic vertical
 	CALL	PUTTRACE
 	LD	A,20H		;space
 	BIT	7,(IY)		;text entry?
 	JR	Z,TRSGY
 	LD	A,'>'
 TRSGY	EX	AF,AF'
 	LD	A,(IY+7)	;text horizontal
 	CALL	PUTTRACE
 	LD	A,(IY+6)	;text vertical
 PUTTRACE
 	PUSH	HL		;save video start
 	PUSH	AF		;save value
 	EX	AF,AF'		;get "active" symbol
 	LD	(HL),A		;display it
 	NOP
 	EX	AF,AF'		;re-save it
 	CALL	INCHL		;point to next posit
 	LD	A,(DE)		;get string byte
 	INC	DE		;bump it
 	LD	(HL),A		;display it
 	NOP
 	CALL	INCHL		;bump HL
 	LD	A,(DE)		;get 2nd string byte
 	INC	DE
 	LD	(HL),A		;display it
 	NOP
 	CALL	INCHL		;bump HL
 	LD	(HL),'='	;right arrow
 	NOP
 	CALL	INCHL		;bump it
 	POP	AF		;restore character
 	CALL	ASCII		;convert to decimal ascii
 	LD	(HL),A		;display it
 	NOP
 	CALL	INCHL
 	LD	(HL),C
 	NOP
 	CALL	INCHL
 	LD	(HL),B		;on screen now
 	NOP
 	POP	HL		;restore original
 	LD	BC,40H		;next line down
 	ADD	HL,BC		;point to it
 	RET			;done
 INCHL	INC	HL		;bump video
 	BIT	6,(IY)		;double wide?
 	RET	Z		;skip if not
 	INC	HL		;else bump again
 	RET
 PUTSNG	LD	HL,BUFFER	;point to buffer
 	LD	DE,3C00H	;move to video
 	LD	BC,1024
 	LDIR
 	NOP
 	JP	RESPUT		;continue
 PRINT	PUSH	HL		;save the string
 	SET	5,(IY)		;video needs update
 PRTLP	LD	A,(HL)		;get a byte
 	INC	HL		;bump it
 	CP	3		;terminator?
 	JR	Z,PRTDN		;done
 	CALL	VOUT		;out to video
 	CP	13		;terminator?
 	JR	NZ,PRTLP
 PRTDN	POP	HL
 	RET
 VOUT	CP	20H		;control code?
 	JP	C,33H		;let ROM do this
 	PUSH	HL		;else save pointer
 	LD	HL,(4020H)	;get cursor
 	LD	(HL),A		;put on screen
 	CP	(HL)		;still there?
 	JR	Z,VIDOK		;lower case in
 	SUB	20H		;else make it upper
 	LD	(HL),A		;put it back
 VIDOK	CALL	INCHL		;bump video
 	LD	(4020H),HL	;update cursor
 	POP	HL		;restore pointer
 	RET			;done
 GET	POP	BC		;restore stack
 	POP	DE
 	POP	HL
 	OR	A		;set flags
 	RET
 INKEY	PUSH	HL		;save all registers
 	PUSH	DE
 	PUSH	BC
 	LD	HL,GET		;unstacker address
 	PUSH	HL
 	IN	A,(0)		;check for joystick
 	CP	0FFH		;check for FFH
 	JP	NZ,JOYSTK	;decode this
 	LD	A,(387FH)	;any keys pressed?
 	OR	A
 	JR	Z,STRPT		;start repeat count if no
 	CP	0		;lastkey
 LIEY	EQU	$-1
 	LD	(LIEY),A
 	JR	NZ,STRPT	;new key
 	LD	A,20		;repeat counter
 RCOUNT	EQU	$-1
 	DEC	A		;less one
 	LD	(RCOUNT),A	;time to repeat?
 	JR	NZ,GETKEY	;fetch a key
 	LD	HL,MASK		;zero out mask area
 	LD	DE,MASK+1
 	LD	BC,6
 	LD	(HL),0
 	LDIR
 STRPT	LD	A,20		;initialize counter
 	LD	(RCOUNT),A	;save it
 GETKEY	LD	HL,MASK		;point to mask area
 	LD	BC,3801H	;keyboard memory
 	LD	D,0		;row counter
 	LD	A,(3840H)
 	AND	2
 	JR	Z,NEXROW
 	LD	A,(3880H)
 	OR	A
 	JR	Z,NEXROW
 	LD	A,3
 	JP	@KEYG
 NEXROW	LD	A,(BC)		;check for key
 	LD	E,A		;save here
 	XOR	(HL)		;check for same as last
 	LD	(HL),E		;save this key
 	AND	E		;same as last?
 	JR	NZ,HAVEIT	;have a new one if NZ
 	INC	D		;bump row counter
 	INC	L		;next mask byte
 	RLC	C		;next keyboard row
 	JP	P,NEXROW	;go next row
 	XOR	A		;nothing here
 	RET			;go back
 HAVEIT	LD	E,A		;save masked byte
 	LD	A,D		;get row counter
 	RLCA			;*2
 	RLCA			;*4
 	RLCA			;*8
 	LD	D,A		;save row*8
 	LD	C,1		;column mask bit
 MKT1	LD	A,C
 	AND	E		;right column?
 	JR	NZ,MKT2		;have it
 	INC	D		;bump counter
 	RLC	C		;shift mask bit
 	JR	MKT1		;conti.ue
 MKT2	LD	E,D		;save LSB
 	LD	D,0		;DE = byte positi/n
 	LD	HL,KEYS1	;keytable #1
 	LD	A,(3840H)	;check for aontrol key
 	AND	2		;on?
 	JR	NZ,GOTKEY	;have the iey
 	LD	HL,IEYS2	;keytable #2
 	LD	A,(3880H)	;check for shift key
 	OR	A		;on?
 	JR	NZ,GOTKEY	;have the key
 	LD	HL,KEYS3	;keytable #3
 GOTKEY	ADD	HL,DE		;point to the byte
 	LD	BC,1800H	;keybounce delay
 	CALL	60H		;wait a bit
 	LD	A,(HL)		;fetch it
 	BIT	7,(IY)
 	RET	Z
 	PUSH	AF
 	LD	BC,800H
 	CALL	60H
 	POP	AF
 	RET
 @KEYG	CALL	@SCPRT
 	XOR	A
 	RET
 JOYSTK	LD	B,'I'
 	CP	0FAH
 	JR	Z,GOTJOY
 	LD	B,'O'
 	CP	0F6H
 	JR	Z,GOTJOY
 	LD	B,'K'
 	CP	0F9H
 	JR	Z,GOTJOY
 	LD	B,'L'
 	CP	0F5H
 	JR	Z,GOTJOY
 	LD	B,5BH
 	BIT	0,A
 	JR	Z,HAVJOY
 	INC	B
 	BIT	1,A
 	JR	Z,HAVJOY
 	INC	B
 	BIT	2,A
 	JR	Z,HAVJOY
 	INC	B
 	BIT	3,A
 	JR	Z,HAVJOY
 	XOR	A
 	RET
 HAVJOY	BIT	4,A
 	JR	NZ,GOTJOY
 	LD	A,B
 	SUB	67
 	LD	B,A
 GOTJOY	LD	A,B
 	PUSH	AF
 	LD	BC,1800H
 	CALL	60H
 	POP	AF
 	RET
 KEYS1	DB	192,193,194,195,196,197,198,199
 	DB	200,201,202,203,204,205,206,207
 	DB	208,209,210,211,212,213,214,215
 	DB	216,217,218,0,0,0,0,0
 	DB	176,177,178,179,180,181,182,183
 	DB	184,185,186,171,188,173,190,191
 	DB	141,0,129,219$220,221,222,160
 KEYS3	DB	'@ABCDEFG'
 	DB	'HIJKLMNO'
 	DB	'PQRSTUVW'
 	DB	'XYZ',0,0,0,0,0
 	DB	'01234567'
 	DB	'89:;,-./'
 	DB	13,0,1,5BH,5CH,5DH,5EH,20H
 KEYS2	DB	'`abcdefg'
 	DB	'hijklmno'
 	DB	'pqrstuvw'
 	DB	'xyz',0,0,0,0,0
 	DB	5FH,'!"#$%&',27H
 	DB	'()*+<=>?'
 	DB	14,0,2,18H,19H,1AH,1BH,7FH
 FLKEY	LD	HL,LFEED	;1 line down
 	CALL	PRINT
 	LD	HL,FLMSG	;flash message
 	EXX			;save here
 	LD	HL,FLMSGB	;clear line message
 FLWAIT	EXX			;swap sets
 	CALL	PRINT		;display the message
 	LD	B,0		;loops
 FLWAITB	CALL	INKEY		;check keyboard
 	CP	13		;enter key?
 	JR	Z,FLDONE	;finished
 	CP	14		;sh enter?
 	JR	Z,FLDONE
 	DJNZ	FLWAITB		;wait some more
 	JR	FLWAIT		;reverse message
 FLDONE	LD	HL,FLMSGB	;clear the line
 	JP	PRINT		;display and return
 KEYTEXT	CALL	INKEY		;check for a key
 	RET	NZ		;done now
 	LD	A,10
 GCNT1	EQU	$-1
 	DEC	A
 	LD	(GCNT1)$A
 	JR	NZ,IEYTEXT
 	LD	A,8
 FLASH1	EQU	$-1
 	LD	(GCNT1),A
 	CALL	FIGTPOS		;figure the position
 	JR	GCNTX
 FIGTPOS	LD	H,(IY+6)	;get position
 	LD	L,(IY+7)
 FIGPOS	LD	DE,0		;start of buffer
 	LD	A,H		;get vertical posit
 YTST	OR	A
 	JR	Z,YHAV		;have the row
 	PUSH	HL		;save this
 	LD	HL,40H		;next row
 	ADD	HL,DE		;point to it
 	EX	DE,HL		;DE has it
 	POP	HL		;restore this
 	DEC	A
 	JR	YTST		;check next row
 YHAV	LD	A,E		;get lsb
 	OR	L		;set with row
 	LD	E,A		;put it back
 	BIT	6,(IY)
 	RET	Z
 	LD	L,E		;save E
 	LD	A,E
 	AND	0C0H
 	LD	E,A
 	LD	A,L
 	AND	3FH
 	SLA	A
 	OR	E
 	LD	E,A
 	RET
 GCNTX	LD	HL,3C00H	;go to video
 	ADD	HL,DE
 	LD	A,0
 GCNT2	EQU	$-1
 	XOR	1
 	LD	(GCNT2),A	;check for on/off
 	LD	A,191		;on block
 	JR	NZ,GHAV
 	LD	A,80H		;off block
 GHAV	LD	(HL),A		;display it
 	NOP
 	JR	KEYTEXT		;continue
 KEYWT	LD	A,(387FH)	;any keys pressed?
 	OR	A
 	JR	NZ,KEYWT	;wait if any are
 KEY	BIT	7,(IY)		;text entry ?
 	JR	NZ,KEYTEXT	;different input
 GKEYLP	CALL	INKEY		;check for a key
 	RET	NZ
 	LD	A,8		;get flash count
 FCNT1	EQU	$-1
 	DEC	A
 	LD	(FCNT1),A	;put it back
 	JR	NZ,GKEYLP	;continue
 	LD	A,8
 FLASH2	EQU	$-1
 	LD	(FCNT1),A	;re-initialize counter
 	LD	A,0		;get set/reset
 FCNT2	EQU	$-1
 	XOR	1		;reverse bit 0
 	LD	(FCNT2),A	;put it back
 	JR	NZ,KESET	;turn on the dot
 	CALL	VRESET		;turn it off
 	JR	GKEYLP		;continue
 KESET	CALL	VSET		;turn it on
 	JR	GKEYLP
 VRESET	LD	HL,3C00H
 	LD	(SBUFF),HL	;do it on video
 	CALL	RESET		;turn it off
 	LD	HL,BUFFER
 	LD	(SBUFF),HL	;restore it
 	RET
 VSET	LD	HL,3C00H
 	LD	(SBUFF),HL
 	CALL	SET
 	LD	HL,BUFFER
 	LD	(SBUFF),HL
 	RET
 SET	LD	A,0C6H
 	JR	TEST10
 POINT	LD	A,46H
 	JR	TEST10
 RESET	LD	A,86H
 TEST10	LD	(INST+1),A
 	LD	D,(IY+4)
 	LD	E,(IY+5)
 DOSET	CALL	SIZFIX
 	LD	A,E
 	INC	H
 	CP	H
 	RET	NC
 	LD	A,D
 ;	INC	L
 ;	CP	L
 ;	RET	NC
 	PUSH	BC
 	LD	B,-1
 LOOPX	INC	B
 	SUB	3
 	JP	P,LOOPX
 	ADD	A,3
 	SLA	A
 	LD	C,A
 	LD	L,B
 	LD	H,0
 	LD	B,6
 LOOPY	ADD	HL,HL
 	DJNZ	LOOPY
 	LD	D,0
 	SRL	E
 	JR	NC,LOOPZ
 	INC	C
 LOOPZ	ADD	HL,DE
 	LD	DE,BUFFER
 SBUFF	EQU	$-2
 	ADD	HL,DE
 	SLA	C
 	SLA	C
 	SLA	C
 	LD	A,(INST+1)
 	ADD	A,C
 	LD	(INST+1),A
 	POP	BC
 	BIT	6,(IY)
 	JR	Z,INST
 	LD	A,L
 	PUSH	AF
 	EX	AF,AF'
 	POP	AF
 	AND	0C0H
 	LD	L,A
 	EX	AF,AF'		;get original
 	AND	3FH
 	SLA	A		;double it
 	OR	L
 	LD	L,A		;have double size now
 INST	DB	0CBH
 	DB	0
 	NOP
 	SET	7,(HL)
 	NOP
 	RET
 FLASH	LD	A,(FLASH1)	;get text flash
 	RRCA			;/2
 	RRCA			;/4
 	RRCA			;/8
 	ADD	A,30H		;make it ascii
 	LD	(TFLASH),A
 	LD	A,(FLASH2)
 	RRCA
 	RRCA
 	RRCA
 	ADD	A,30H
 	LD	(GFLASH),A
 	LD	HL,FMSG1
 	CALL	ASKFLS		;ask for it
 	JR	Z,GFL2
 	SLA	A
 	SLA	A
 	SLA	A
 	LD	(FLASH2),A	;save it
 GFL2	LD	HL,FMSG2	;text flash
 	CALL	ASKFLS
 	JP	Z,RESUME
 	SLA	A
 	SLA	A
 	SLA	A
 	LD	(FLASH1),A	;save this too
 	JP	RESUME		;continue
 ASKFLS	CALL	PRINT		;display message
 	LD	B,1		;1 char input
 	CALL	GETSTR		;get fromkeyboard
 	RET	Z
 	SUB	31H		;test 1-9
 	JR	C,FIXFLS
 	CP	9
 	JR	NC,FIXFLS
 	INC	A		;adjust for 1-9
 	RET
 FIXFLS	JP	RESUME		;continue
 ANGLES	LD	A,(IY+2)	;get horizontal
 	ADD	A,30H		;make it ascii
 	LD	(HMUCH),A	;put in string
 	LD	A,(IY+3)	;get vertical speed
 	ADD	A,30H
 	LD	(VMUCH),A
 	LD	HL,AMSG1	;first message
 	CALL	ASKFLS		;get the input
 	JR	Z,DOSK1
 	LD	(IY+2),A	;resave it
 DOSK1	LD	HL,AMSG2	;second message
 	CALL	ASKFLS
 	JR	Z,DOSK2
 	LD	(IY+3),A
 DOSK2	LD	HL,AMSG3	;3rd messge
 	CALL	PRINT
 	LD	B,1
 	CALL	GETSTR
 	JP	Z,RESUME
 	CALL	UCASE
 	SET	2,(IY)
 	CP	'D'
 	JP	Z,RESUME
 	RES	2,(IY)
 	JP	RESUME
 HEXCV	LD	B,A		;convert char in A to
 	SRL	A		;HEX ascii in CB
 	SRL	A
 	SRL	A
 	SRL	A
 	CALL	HEXTST
 	LD	C,A
 	LD	A,B
 	AND	0FH
 	CALL	HEXTST
 	LD	B,A
 	RET
 HEXTST	ADD	A,30H
 	CP	3AH
 	RET	M
 	ADD	A,7
 	RET
 ASCII	PUSH	HL		;convert number in A
 	CALL	ASCI		;to decimal ascii in ACB
 	LD	H,B
 	PUSH	HL
 	LD	A,C
 	SUB	30H
 	CALL	ASCI
 	LD	A,C
 ASCIGO1	POP	HL
 	LD	C,B
 	LD	B,H
 	POP	HL
 	RET
 ASCI	LD	C,'0'
 ASCII1	SUB	10
 	JR	C,ASCII2
 	INC	C
 	JR	ASCII1
 ASCII2	ADD	A,3AH
 	LD	B,A
 	RET
 ASKFILE	LD	HL,FILEMSG	;filename message
 	CALL	PRINT		;display it
 	LD	B,14		;14 chars possible
 	LD	HL,DCB		;where to put the data
 	CALL	WAITKEY		;get key input
 	EX	DE,HL
 	JP	Z,RESUME
 	PUSH	BC
 	PUSH	DE
 FIXFL	LD	A,(DE)		;make all uppercase
 	CALL	UCASE
 	LD	(DE),A
 	INC	DE
 	DJNZ	FIXFL
 	POP	DE
 	LD	HL,DEFEXT	;/DRW
 	LD	A,(IY-1)
 	BIT	3,A
 	JR	Z,DODEF
 	AND	7
 	JR	Z,DODEF
 	LD	HL,DEFASM	;/ASM
 	DEC	A
 	JR	Z,DODEF
 	DEC	A
 	JR	Z,DODEF
 	LD	HL,DEFBAS	;/BAS
 	DEC	A
 	JR	Z,DODEF
 	DEC	A
 	JR	Z,DODEF
 	LD	HL,DEFCMD	;/CMD
 DODEF	CALL	ADDEXT		;add default extension
 	POP	BC		;restore length
 	RET
 LOAD	LD	HL,LOADMSG	;loading message
 	CALL	PRINT		;display it
 	RES	3,(IY-1)	;set LOAD flag
 	CALL	DISKTAPE	;setup parameters
 	LD	HL,IOBUFF	;where data goes
 	LD	DE,DCB
 	LD	(IY+8),1
 	LD	(IY+9),0
 	CALL	RDBUFF		;read 256 bytes
 	JP	NZ,CERROR	;no good
 	LD	HL,IOBUFF	;check for valid
 	LD	DE,QUICK
 	LD	B,21		;21 bytes must match
 	CALL	COMPARE		;test 'em
 	JR	Z,RVALID	;ok to read
 INVALID	CALL	CLSBUFF
 	LD	HL,VALMSG	;invalid data
 	CALL	PRINT
 	CALL	FLKEY
 	JP	RESUME		;continue
 RVALID	LD	BC,0E600H	;40 loops through
 	LD	(IY+10),L	;save position
 	LD	(IY+11),H
 LCKLP	LD	A,(HL)		;get a slot
 	CP	99
 	JR	NZ,CKLP
 	INC	C		;bump counter
 CKLP	INC	HL		;bump table
 	DJNZ	LCKLP		;do 'em all
 	PUSH	BC		;save it
 	LD	A,C		;get result
 	LD	(IY+8),A
 	CALL	ASCII		;make it ascii
 	LD	(RDMSG),BC	;save it in string
 	LD	HL,RDMSG	;reading message
 	CALL	PRINT		;display it
 	POP	BC		;restore count
 	LD	A,(IY+1)	;get # available
 	CP	C		;test
 	JR	NC,LOADLPX	;enough to read 'em
 	CALL	CLSBUFF
 	LD	HL,MEMMSG	;not enough memory
 	CALL	PRINT
 	CALL	FLKEY		;flash for key
 	JP	RESUME		;resume action
 LOADLPX	LD	L,(IY+10)	;get position back
 	LD	H,(IY+11)
 	LD	DE,STRING	;save data here for now
 	PUSH	DE		;save this
 	LD	BC,230		;230 entries possible
 	LDIR			;move it in
 	LD	A,(IY+8)	;get # buffers
 	SLA	A		;*2
 	SLA	A		;*4
 	LD	(IY+8),A	;# sectors to read
 	CALL	ASCII
 	BIT	7,(IY-1)
 	JR	Z,SKPSHW
 	LD	(3C7DH),A
 	LD	(3C7EH),BC
 SKPSHW	POP	HL		;hl => bufftable
 	LD	BC,0E601H	;40 entries, C counter
 LOADLP	LD	A,(HL)		;get a byte
 	CP	99		;anything there?
 	JR	NZ,NEXTLD	;skip if not
 	LD	A,C		;get buff #
 	LD	(IY+12),A	;save here
 	INC	A
 	CP	(IY+1)
 	JR	NC,NEXTLD
 	PUSH	HL		;save pointer
 	PUSH	BC		;save counter
 	LD	HL,BUFFTABLE-1	;buffer table
 	LD	B,0
 	ADD	HL,BC
 	LD	(HL),99		;buffer has data
 	LD	HL,BUFFER
 	LD	DE,400H
 FIXB1	ADD	HL,DE
 	DEC	C
 	JR	NZ,FIXB1
 	LD	B,4		;4 sectors / screen
 RDLP	PUSH	HL		;save pointer
 	PUSH	BC
 	LD	DE,DCB		;read a sector
 	LD	HL,IOBUFF
 	CALL	RDBUFF		;read the buffer
 	POP	BC		;restore count
 	POP	HL		;restore pointer
 	JR	NZ,BADLD	;no good
 	EX	DE,HL		;put the bytes there
 	PUSH	BC		;save this
 	LD	HL,IOBUFF
 	LD	BC,100H
 	LDIR			;move 'em
 	EX	DE,HL
 	POP	BC		;done here
 	DJNZ	RDLP
 	POP	BC		;restore stack
 	POP	HL
 NEXTLD	INC	HL		;bump table pointer
 	INC	C
 	DJNZ	LOADLP		;continue for 230 entries
 	CALL	CLSBUFF		;close files
 	CALL	FLKEY
 	JP	RESUME		;load completed
 BADLD	POP	BC		;restore stack
 	POP	HL
 	JP	CERROR
 COMPARE	LD	A,(DE)		;compare buffers
 	CP	(HL)
 	INC	DE
 	INC	HL
 	RET	NZ
 	DJNZ	COMPARE
 	RET
 ERROR	OR	0C0H		;for return
 	CALL	4409H		;display DOS error
 	CALL	FLKEY		;wait for key
 	JP	RESUME		;clear and continue
 SAVE	LD	HL,SAVEMSG	;saving message
 	CALL	PRINT
 	SET	3,(IY-1)	;set SAVE operation
 	LD	B,(IY+1)
 	LD	C,0
 	LD	HL,BUFFTABLE
 SVLP	LD	A,(HL)
 	CP	99
 	JR	NZ,SVLP1
 	INC	C
 SVLP1	INC	HL
 	DJNZ	SVLP
 	LD	A,C		;get count
 	LD	(IY+8),A
 	OR	A
 	JR	NZ,SVCONT	;continue
 	LD	HL,NOSAVE	;nothing to save
 	CALL	PRINT
 	CALL	FLKEY		;wait for ENTER
 	JP	RESUME		;continue
 SVCONT	CALL	ASCII		;# buffer=>ascii
 	LD	(SAVNUM),BC	;put in string
 	LD	A,(IY+8)
 	SLA	A
 	SLA	A
 	INC	A
 	LD	(IY+8),A
 	LD	(IY+9),1
 	LD	HL,PUTMSG	;# of buffers
 	CALL	PRINT
 	CALL	DISKTAPE	;setup parameters
 	BIT	7,(IY-1)
 	JP	NZ,NOWTHERE	;continue if tape
 	JR	C,THERENOW	;new file created
 	LD	HL,THEREMSG	;see if yes/no
 	CALL	PRINT		;display it
 	LD	B,3		;3 char input
 	CALL	GETSTR		;get request
 	JP	Z,RESUME	;cancel it
 	CALL	UCASE		;make it upper
 	CP	'Y'		;must be YES
 	JP	NZ,RESUME	;quit now
 	JR	NOWTHERE
 THERENOW
 	LD	HL,THRMSG
 	CALL	PRINT
 NOWTHERE	LD	HL,IOBUFF
 	LD	DE,IOBUFF+1
 	LD	BC,0FFH
 	LD	(HL),0
 	LDIR			;clear the buffer
 	LD	HL,QUICK	;insert identity
 	LD	DE,IOBUFF
 	LD	BC,21
 	LDIR
 	LD	HL,BUFFTABLE
 	LD	BC,230
 	LDIR
 	LD	DE,DCB		;point to DCB
 	LD	HL,IOBUFF
 	CALL	WRBUFF		;write the buffer
 	JP	NZ,CERROR	;close and return
 	LD	HL,BUFFTABLE
 	LD	B,(IY+1)
 	LD	C,1
 SVLOOP	LD	A,(HL)		;get a byte
 	CP	99		;anything ?
 	JR	NZ,NEXTSAV	;skip it
 	LD	A,C		;get buff #
 	LD	(IY+12),A
 	PUSH	HL
 	PUSH	BC
 	LD	HL,BUFFER
 	LD	DE,400H
 FIGB2	ADD	HL,DE
 	DEC	C
 	JR	NZ,FIGB2
 	LD	B,4		;4 sectors/screen
 SSAVLP	PUSH	BC
 	LD	DE,IOBUFF	;move data to buffer
 	LD	BC,100H
 	LDIR
 	PUSH	HL
 	LD	DE,DCB
 	LD	HL,IOBUFF
 	CALL	WRBUFF2		;write the buffer
 	POP	HL
 	POP	BC
 	JR	NZ,BADSAV
 	DJNZ	SSAVLP
 	POP	BC
 	POP	HL
 NEXTSAV	INC	HL
 	INC	C
 	DJNZ	SVLOOP
 	LD	A,(IY-1)	;check for special write
 	AND	7
 	CALL	NZ,FLUSH	;write last data back
 	CALL	CLSBUFF
 	JP	NZ,ERROR	;print error
 	CALL	FLKEY
 	JP	RESUME
 BADSAV	POP	BC
 	POP	HL
 CERROR	PUSH	AF		;save error code
 	CALL	CLSBUFF		;close it
 	JR	Z,OKDONE	;ok, done
 	OR	0C0H
 	CALL	4409H		;display THIS error
 OKDONE	POP	AF		;restore original error
 	JP	ERROR		;print this one now
 CLSBUFF	LD	DE,DCB		;point to DCB
 	BIT	7,(IY-1)	;from disk ?
 	JR	NZ,CLSTAPE	;turn off tape
 	BIT	3,(IY-1)
 	RET	Z
 	LD	A,(DE)		;get a byte
 	BIT	7,A		;open now?
 	RET	Z
 	JP	4428H		;close it
 CLSTAPE	CALL	01F8H		;turn off cassette
 	XOR	A		;set Z flag
 	RET
 GETSTR	LD	HL,STRING	;point to string
 WAITKEY	LD	A,(387FH)
 	OR	A
 	JR	NZ,WAITKEY
 	PUSH	IY
 	CALL	40H
 	POP	IY
 	JP	C,RESUME	;cancel
 	LD	A,B		;get length of input
 	OR	A		;set flags
 	LD	A,(HL)		;get first character
 	RET
 UCASE	CP	60H		;upper case now?
 	RET	C
 	CP	80H
 	RET	NC
 	AND	5FH
 	RET
 DOBUFF	LD	A,(IY+1)	;get number of buffers
 	CALL	ASCII		;convert to ascii
 	LD	(BUFNUM),BC	;save it
 	LD	HL,BUFMSG	;header
 	CALL	PRINT		;display it
 	CALL	PARAMS		;show settings
 	LD	HL,BUFMSG0
 	CALL	PRINT
 	LD	B,1
 	CALL	GETSTR		;get answer
 	JP	Z,RESUME
 	CALL	UCASE		;make it upper
 	CP	'S'		;save to buffer?
 	JP	Z,SAVBUF
 	CP	'R'		;restore a buffer
 	JP	Z,RESBUF
 	CP	'C'		;clear all?
 	JP	Z,ERABUF
 	CP	'Z'
 	JP	Z,ZROBUF
 	CP	'M'
 	JP	Z,MERGBUF
 	CP	'E'		;exchange?
 	JP	NZ,RESUME	;forget it
 	LD	HL,EBFMSG	;exchange what?
 	CALL	ASKBUF		;which one?
 	LD	DE,BUFFER	;exchange here
 	LD	BC,400H		;1k to do
 EXCHG	LD	A,(DE)		;get a byte
 	EX	AF,AF'		;save it
 	LD	A,(HL)		;get other one
 	LD	(DE),A		;swap one
 	EX	AF,AF'
 	LD	(HL),A		;fix this one now
 	INC	DE		;bump buffers
 	INC	HL
 	DEC	BC		;counter
 	LD	A,B
 	OR	C
 	JR	NZ,EXCHG	;go till all done
 	LD	A,99		;set active
 	JR	SETACT
 MERGBUF	LD	HL,MBUFMSG
 	CALL	ASKBUF
 	LD	DE,BUFFER
 	LD	BC,400H		;one screen full
 MERLP	LD	A,(HL)		;get a byte
 	CP	20H
 	JR	Z,SKPM
 	CP	80H
 	JR	Z,SKPM
 	LD	(DE),A		;put on video
 SKPM	INC	HL
 	INC	DE
 	DEC	BC
 	LD	A,B
 	OR	C
 	JR	NZ,MERLP
 	SET	5,(IY)
 	JP	RESUME
 SAVBUF	LD	HL,SBFMSG	;save buffer
 	CALL	ASKBUF		;get reply
 	LD	DE,BUFFER	;point to buffer
 	EX	DE,HL		;video => buffer
 CONBUF	LD	BC,400H
 	LDIR			;move 'em
 	LD	A,99		;set active
 SETACT	LD	E,(IY+8)	;get position
 	LD	D,(IY+9)
 	LD	(DE),A		;save value
 	JP	RESUME		;continue
 RESBUF	LD	HL,RBFMSG
 	CALL	ASKBUF
 	LD	DE,BUFFER
 	LD	BC,400H
 	LDIR
 	JP	RESUME
 ERABUF	LD	A,(IY+1)	;get counter
 	LD	HL,BUFFER+400H	;start of area
 	LD	DE,BUFFER+401H
 	LD	(HL),80H	;spaces
 ELOP	LD	BC,400H
 	LDIR			;zero it out
 	DEC	A		;countdown
 	JR	NZ,ELOP
 	LD	HL,BUFFTABLE	;zero buffer table
 	LD	DE,BUFFTABLE+1
 	LD	(HL),0
 	LD	BC,229
 	LDIR
 	JP	RESUME
 ZROBUF	LD	HL,ZBFMSG
 	CALL	ASKBUF		;clear 1 buffer
 	LD	D,H		;pass to DE
 	LD	E,L
 	INC	DE		;+1
 	LD	BC,3FFH		;1 screen
 	LD	(HL),80H
 	LDIR
 	XOR	A
 	JP	SETACT		;de-activate the buffer
 ASKBUF	CALL	PRINT		;display prompt
 	LD	HL,UBFMSG
 	CALL	PRINT		;finish it
 	LD	B,2		;2 chars only
 	CALL	GETSTR		;get reply
 	JR	Z,BUFNOP	;cancel
 	CALL	VALUE		;get value of answer
 	JR	C,BUFNOP	;invalid input
 	LD	A,(IY+1)	;get total number
 	CP	C
 	JR	C,BUFNOP
 	LD	A,C
 	OR	A
 	JR	Z,BUFNOP
 	LD	HL,BUFFER	;start
 	LD	DE,400H		;displacement
 COMPBF	ADD	HL,DE
 	DEC	C
 	JR	NZ,COMPBF
 	LD	DE,BUFFTABLE-1	;point to table
 	PUSH	HL
 	LD	H,0
 	LD	L,A
 	ADD	HL,DE
 	LD	(IY+8),L
 	LD	(IY+9),H	;save the value
 	POP	HL
 	RET
 VALUE	LD	C,0		;start value
 VALLP	LD	A,(HL)		;get a number
 	CALL	CKVAL		;good
 	RET	C
 	LD	C,A		;ok
 	INC	HL
 	LD	A,(HL)		;ok?
 	CP	13		;terminator?
 	RET	Z		;done
 	CALL	CKVAL		;good?
 	RET	C		;nope
 	LD	B,A		;save here
 	LD	A,C		;get first
 	ADD	A,A		;*2
 	ADD	A,A		;*4
 	ADD	A,C		;*5
 	ADD	A,A		;*10
 	ADD	A,B		;add second number
 	LD	C,A
 	OR	A		;clear carry
 	RET
 CKVAL	SUB	30H		;remove ascii
 	RET	C		;no good
 	CP	10
 	CCF
 	RET			;C flag if bad
 BUFNOP	JP	RESUME
 PARAMETERS
 	LD	HL,PARMSG
 	CALL	PRINT
 	CALL	PARAMS
 	JP	PARAMRET
 PARAMS	LD	HL,(4020H)	;get cursor
 	LD	B,(IY+1)	;# of buffers
 	LD	C,1		;counter
 PARLP	PUSH	BC		;save this
 	LD	A,C		;get position
 	PUSH	AF
 	CALL	ASCII		;make it ascii
 	LD	(HL),C		;MSB
 	INC	HL
 	LD	(HL),B		;LSB
 	INC	HL
 	LD	(HL),'='
 	INC	HL
 	POP	AF		;A = positin
 	LD	C,A
 	LD	B,0
 	PUSH	HL		;save this
 	LD	HL,BUFFTABLE-1
 	ADD	HL,BC		;point to byte
 	LD	A,(HL)
 	CP	99		;active?
 	POP	HL
 	POP	BC		;stack fixed
 	JR	NZ,DEADSPT
 	LD	(HL),143
 	INC	HL
 	LD	(HL),143
 	INC	HL
 	LD	(HL),143
 	JR	DEADCNT
 DEADSPT	INC	HL
 	INC	HL
 DEADCNT	INC	HL
 	INC	HL
 	INC	HL
 	INC	C
 	DJNZ	PARLP
 	LD	(4020H),HL
 	LD	HL,LFEED
 	JP	PRINT
 PARAMRET	CALL	FLKEY	;wait for enter
 	JP	RESUME
 DUBREV	LD	B,16
 	LD	HL,BUFFER
 	LD	DE,BUFFER+20H
 DUBL1	PUSH	HL
 	PUSH	DE
 	LD	C,32
 DUBL2	LD	A,(HL)
 	EX	AF,AF'
 	LD	A,(DE)
 	LD	(HL),A
 	EX	AF,AF'
 	LD	(DE),A
 	INC	HL
 	INC	DE
 	DEC	C
 	JR	NZ,DUBL2
 	POP	DE
 	POP	HL
 	PUSH	BC
 	LD	BC,40H
 	ADD	HL,BC
 	EX	DE,HL
 	ADD	HL,BC
 	EX	DE,HL
 	POP	BC
 	DJNZ	DUBL1
 	SET	5,(IY)
 	JP	RESUME
